<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Debugging</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Debugging<br/>
<small>
[<a class="el" href="group__m17nMisc.html">MISC API</a>]</small>
</h1>
<p>Support for m17n library users to debug their programs.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#gaf1a509be097e9dc29a79652e57a1b96e">mdebug_dump_chartab</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table, int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump a chartable.  <a href="#gaf1a509be097e9dc29a79652e57a1b96e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFace.html#gad9e913e845df8db71f448e3aca2b83b5">MFace</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga300fc806866e630fda617ff8cc135615">mdebug_dump_face</a> (<a class="el" href="group__m17nFace.html#gad9e913e845df8db71f448e3aca2b83b5">MFace</a> *face, int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump a face.  <a href="#ga300fc806866e630fda617ff8cc135615"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#gad9670bbd4f4db66cb231213d215010b2">mdebug_dump_font</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump a font.  <a href="#gad9670bbd4f4db66cb231213d215010b2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga03ad3b1fffd4f64b5f1c5646f5a85648">mdebug_dump_fontset</a> (<a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *fontset, int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump a fontset.  <a href="#ga03ad3b1fffd4f64b5f1c5646f5a85648"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputMethod.html">MInputMethod</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga8844c814bf108e3c614ffb41ba810f3c">mdebug_dump_im</a> (<a class="el" href="structMInputMethod.html">MInputMethod</a> *im, int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump an input method.  <a href="#ga8844c814bf108e3c614ffb41ba810f3c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga8b0933991939cadcaed4399a60c9b9db">mdebug_hook</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Hook function called on an error.  <a href="#ga8b0933991939cadcaed4399a60c9b9db"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga52ba04c9aee68a3b57700c6c9f003589">mdebug_dump_mtext</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int indent, int fullp)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump an M-text.  <a href="#ga52ba04c9aee68a3b57700c6c9f003589"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga130be9986f29171365089b39a3368c28">mdebug_dump_plist</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump a property list.  <a href="#ga130be9986f29171365089b39a3368c28"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga9c889e8d4c7730e4f5ff78c9a57fc11f">mdebug_dump_symbol</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump a symbol.  <a href="#ga9c889e8d4c7730e4f5ff78c9a57fc11f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga04577301857b34f7e50e235bc06fd213">mdebug_dump_all_symbols</a> (int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump all symbol names.  <a href="#ga04577301857b34f7e50e235bc06fd213"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Support for m17n library users to debug their programs. </p>
<p>The m17n library provides the following facilities to support the library users to debug their programs.</p>
<ul>
<li>
<p class="startli">Environment variables to control printing of various information to stderr.</p>
<ul>
<li>
<p class="startli">MDEBUG_INIT -- If set to 1, print information about the library initialization on the call of <a class="el" href="group__m17nIntro.html#ga66879b35a1fee08b3e5966f6650c39f9" title="Initialize the m17n library.">M17N_INIT()</a>.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_FINI -- If set to 1, print counts of objects that are not yet freed on the call of <a class="el" href="group__m17nIntro.html#gac1e2228145ac9d98c6cf4fea8e9d84d4" title="Finalize the m17n library.">M17N_FINI()</a>.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_CHARSET -- If set to 1, print information about charsets being loaded from the m17n database.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_CODING -- If set to 1, print information about coding systems being loaded from the m17n database.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_DATABASE -- If set to 1, print information about data being loaded from the m17n database.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_FONT -- If set to 1, print information about fonts being selected and opened.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_FLT -- If set to 1, 2, or 3, print information about which command of Font Layout Table are being executed. The bigger number prints the more detailed information.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_INPUT -- If set to 1, print information about how an input method is running.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_ALL -- Setting this variable to 1 is equivalent to setting all the above variables to 1.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">MDEBUG_OUTPUT_FILE -- If set to a file name, the above debugging information is appended to the file. If set to "stdout", the information is printed to stdout.</p>
<p class="endli"></p>
</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli">Functions to print various objects in a human readable way. See the documentation of mdebug_dump_XXXX() functions.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">The hook function called on an error. See the documentation of <a class="el" href="group__m17nDebug.html#ga8b0933991939cadcaed4399a60c9b9db" title="Hook function called on an error.">mdebug_hook()</a>.</p>
<p class="endli"></p>
</li>
</ul>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="gaf1a509be097e9dc29a79652e57a1b96e"></a><!-- doxytag: member="chartab.c::mdebug_dump_chartab" ref="gaf1a509be097e9dc29a79652e57a1b96e" args="(MCharTable *table, int indent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a>* mdebug_dump_chartab </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump a chartable. </p>
<p>The <a class="el" href="group__m17nDebug.html#gaf1a509be097e9dc29a79652e57a1b96e" title="Dump a chartable.">mdebug_dump_chartab()</a> function prints a chartable <b>table</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>table</b>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga300fc806866e630fda617ff8cc135615"></a><!-- doxytag: member="face.c::mdebug_dump_face" ref="ga300fc806866e630fda617ff8cc135615" args="(MFace *face, int indent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFace.html#gad9e913e845df8db71f448e3aca2b83b5">MFace</a>* mdebug_dump_face </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFace.html#gad9e913e845df8db71f448e3aca2b83b5">MFace</a> *&nbsp;</td>
          <td class="paramname"> <em>face</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump a face. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga300fc806866e630fda617ff8cc135615" title="Dump a face.">mdebug_dump_face()</a> function prints face <b>face</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>face</b>. </dd></dl>

</div>
</div>
<a class="anchor" id="gad9670bbd4f4db66cb231213d215010b2"></a><!-- doxytag: member="font.c::mdebug_dump_font" ref="gad9670bbd4f4db66cb231213d215010b2" args="(MFont *font)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mdebug_dump_font </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump a font. </p>
<p>The <a class="el" href="group__m17nDebug.html#gad9670bbd4f4db66cb231213d215010b2" title="Dump a font.">mdebug_dump_font()</a> function prints font <b>font</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>font</b>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga03ad3b1fffd4f64b5f1c5646f5a85648"></a><!-- doxytag: member="fontset.c::mdebug_dump_fontset" ref="ga03ad3b1fffd4f64b5f1c5646f5a85648" args="(MFontset *fontset, int indent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a>* mdebug_dump_fontset </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td>
          <td class="paramname"> <em>fontset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump a fontset. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga03ad3b1fffd4f64b5f1c5646f5a85648" title="Dump a fontset.">mdebug_dump_fontset()</a> function prints fontset <b>fontset</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>fontset</b>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga8844c814bf108e3c614ffb41ba810f3c"></a><!-- doxytag: member="input.c::mdebug_dump_im" ref="ga8844c814bf108e3c614ffb41ba810f3c" args="(MInputMethod *im, int indent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structMInputMethod.html">MInputMethod</a>* mdebug_dump_im </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structMInputMethod.html">MInputMethod</a> *&nbsp;</td>
          <td class="paramname"> <em>im</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump an input method. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga8844c814bf108e3c614ffb41ba810f3c" title="Dump an input method.">mdebug_dump_im()</a> function prints the input method <b>im</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>im</b>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga8b0933991939cadcaed4399a60c9b9db"></a><!-- doxytag: member="m17n&#45;core.c::mdebug_hook" ref="ga8b0933991939cadcaed4399a60c9b9db" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdebug_hook </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Hook function called on an error. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga8b0933991939cadcaed4399a60c9b9db" title="Hook function called on an error.">mdebug_hook()</a> function is called when an error happens. It returns -1 without doing anything. It is useful to set a break point on this function in a debugger. </p>

</div>
</div>
<a class="anchor" id="ga52ba04c9aee68a3b57700c6c9f003589"></a><!-- doxytag: member="mtext.c::mdebug_dump_mtext" ref="ga52ba04c9aee68a3b57700c6c9f003589" args="(MText *mt, int indent, int fullp)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* mdebug_dump_mtext </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>fullp</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump an M-text. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga52ba04c9aee68a3b57700c6c9f003589" title="Dump an M-text.">mdebug_dump_mtext()</a> function prints the M-text <b>mt</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one. If <b>fullp</b> is zero, this function prints only a character code sequence. Otherwise, it prints the internal byte sequence and text properties as well.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>mt</b>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga130be9986f29171365089b39a3368c28"></a><!-- doxytag: member="plist.c::mdebug_dump_plist" ref="ga130be9986f29171365089b39a3368c28" args="(MPlist *plist, int indent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mdebug_dump_plist </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump a property list. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga130be9986f29171365089b39a3368c28" title="Dump a property list.">mdebug_dump_plist()</a> function prints a property list <b>plist</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>plist</b>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga9c889e8d4c7730e4f5ff78c9a57fc11f"></a><!-- doxytag: member="symbol.c::mdebug_dump_symbol" ref="ga9c889e8d4c7730e4f5ff78c9a57fc11f" args="(MSymbol symbol, int indent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> mdebug_dump_symbol </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump a symbol. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga9c889e8d4c7730e4f5ff78c9a57fc11f" title="Dump a symbol.">mdebug_dump_symbol()</a> function prints symbol <b>symbol</b> in a human readable way to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <b>symbol</b>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd>MERROR_DEBUG </dd></dl>

</div>
</div>
<a class="anchor" id="ga04577301857b34f7e50e235bc06fd213"></a><!-- doxytag: member="symbol.c::mdebug_dump_all_symbols" ref="ga04577301857b34f7e50e235bc06fd213" args="(int indent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> mdebug_dump_all_symbols </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>indent</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dump all symbol names. </p>
<p>The <a class="el" href="group__m17nDebug.html#ga04577301857b34f7e50e235bc06fd213" title="Dump all symbol names.">mdebug_dump_all_symbols()</a> function prints names of all symbols to the stderr or to what specified by the environment variable MDEBUG_OUTPUT_FILE. <b>indent</b> specifies how many columns to indent the lines but the first one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd>MERROR_DEBUG </dd></dl>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
